#ifndef __HARDWARE__
#define __HARDWARE__

// 4 MHz
#define F_CPU 4000000UL  

#include <avr/io.h>
#include <avr/interrupt.h> 
#include <util/delay.h>

#define LED_PORT		PORTC
#define LED_DDR			DDRC
#define LED1_BIT		_BV(3)
#define LED2_BIT		_BV(4)
#define LED3_BIT		_BV(5)

#define SW_PORT			PORTC
#define SW_PIN			PINC
#define SW_DDR			DDRC
#define SW1_BIT			_BV(0)
#define SW2_BIT			_BV(1)
#define SW3_BIT			_BV(2)

/*
#define RF_MOSI_DDR			DDRD
#define RF_MOSI_PORT		PORTD
#define RF_MOSI_BIT			_BV(7)
#define RF_MISO_DDR			DDRB
#define RF_MISO_PIN			PINB
#define RF_MISO_PORT		PORTB
#define RF_MISO_BIT			_BV(0)
#define RF_SCK_DDR			DDRD
#define RF_SCK_PORT			PORTD
#define RF_SCK_BIT			_BV(6)
#define RF_IRQ_BIT			_BV(3)
#define RF_NSEL_DDR			DDRB
#define RF_NSEL_PORT		PORTB
#define RF_NSEL_BIT			_BV(1)
*/

#define DDR_IN					0
#define DDR_OUT					1

#define PORT_SEL				PORTB
#define PIN_SEL					PINB
#define DDR_SEL					DDRB

#define PORT_SDI				PORTD
#define PIN_SDI					PIND
#define DDR_SDI					DDRD

#define PORT_SCK				PORTD
#define PIN_SCK					PIND
#define DDR_SCK					DDRD

#define PORT_SDO				PORTB
#define PIN_SDO					PINB
#define DDR_SDO					DDRB

/*#define PORT_DATA				PORTD
#define PIN_DATA				PIND
#define DDR_DATA				DDRD*/

#define RFXX_SCK				6
#define RFXX_SDO				0
#define RFXX_SDI				7
#define RFXX_SEL			 	1

#define SEL_OUTPUT()		DDR_SEL |= (1<<RFXX_SEL)
#define HI_SEL()				PORT_SEL |= (1<<RFXX_SEL)
#define LOW_SEL()				PORT_SEL &= ~(1<<RFXX_SEL)

#define SDI_OUTPUT()		DDR_SDI |= (1<<RFXX_SDI)
#define HI_SDI()				PORT_SDI |= (1<<RFXX_SDI)
#define LOW_SDI()				PORT_SDI &= ~(1<<RFXX_SDI)

#define SDO_INPUT()			DDR_SDO &= ~(1<<RFXX_SDO)
#define SDO_HI()				PIN_SDO & (1<<RFXX_SDO)

#define SCK_OUTPUT()		DDR_SCK |= (1<<RFXX_SCK)
#define HI_SCK()				PORT_SCK |= (1<<RFXX_SCK)
#define LOW_SCK()				PORT_SCK &= ~(1<<RFXX_SCK)

#define LEDG_OUTPUT()		DDRC |= (1<<0)
#define LEDR_OUTPUT()		DDRC |= (1<<1)

#define LEDG_OFF()			PORTC |= (1<<3)
#define LEDG_ON()				PORTC &= ~(1<<3)
#define LEDR_OFF()			PORTC |= (1<<4)
#define LEDR_ON()				PORTC &= ~(1<<4)

#define PORT_IRQ				PORTD
#define PIN_IRQ					PIND
#define DDR_IRQ					DDRD
#define RF12_IRQ				3
#define IRQ_IN()				DDR_IRQ &= ~(1<<RF12_IRQ)
#define WAIT_IRQ_LOW()	while (PIND & (1<<RF12_IRQ))

#endif // __HARDWARE__
