#include "hardware.h"
#include "uart.h"

#define UBRR			(F_CPU/16/BAUD)

void uart_init(void)
{
	UBRRH = (unsigned char)(UBRR>>8);
	UBRRL = (unsigned char)UBRR;

	UCSRB = _BV(RXEN) | _BV(TXEN);
	UCSRC = _BV(URSEL) | _BV(USBS) | _BV(UCSZ1) | _BV(UCSZ0);
}

void uart_transmit( unsigned char data )
{
	while ( !( UCSRA & _BV(UDRE)) )
		;
	UDR = data;
}

unsigned char uart_receive( void )
{
	while ( !(UCSRA & _BV(RXC)) )
		;

	return UDR;
}

unsigned char uart_try_receive(unsigned char* byte)
{
	if ( !(UCSRA & _BV(RXC)) )
		return 0;

	*byte = UDR;
	return 1;
}

void uart_send_string(const char* s)
{
	while (*s)
		uart_transmit(*s++);
}


